require 'java'

import javax.management.ObjectName
import javax.management.remote.JMXConnectorFactory
import javax.management.remote.JMXServiceURL

module Riemann
  module Cassandra
    class Client
      attr_reader :mbean_server_connection

      def initialize(hostname, port)
        @service_url = JMXServiceURL.new("service:jmx:rmi:///jndi/rmi://#{hostname}:#{port}/jmxrmi")
        @mbean_server_connection = JMXConnectorFactory.connect(@service_url, nil).getMBeanServerConnection
      end

      def metric(type, scope, name, attribute)
        jmx_path = "org.apache.cassandra.metrics:type=#{type},scope=#{scope},name=#{name}"
        mbean_server_connection.get_attribute(ObjectName.new(jmx_path), attribute)
      end
    end
  end
end
