module Riemann
  module Cassandra
    # https://www.datadoghq.com/blog/how-to-collect-cassandra-metrics/
    METRIC_PARAMS = [
      { service: 'read_throughput',              type: 'ClientRequest', scope: 'Read',     name: 'Latency',      attribute: 'OneMinuteRate', description: '' },
      { service: 'write_throughput',             type: 'ClientRequest', scope: 'Write',    name: 'Latency',      attribute: 'OneMinuteRate', description: '' },
      { service: 'total_read_latency',           type: 'ClientRequest', scope: 'Read',     name: 'TotalLatency', attribute: 'Count',         description: '' },
      { service: 'total_write_latency',          type: 'ClientRequest', scope: 'Write',    name: 'TotalLatency', attribute: 'Count',         description: '' },
      { service: 'read_latency',                 type: 'ClientRequest', scope: 'Read',     name: 'Latency',      attribute: 'Count',         description: '' },
      { service: 'write_latency',                type: 'ClientRequest', scope: 'Write',    name: 'Latency',      attribute: 'Count',         description: '' },
      { service: 'key_cache_hits',               type: 'Cache',         scope: 'KeyCache', name: 'Hits',         attribute: 'Count',         description: '' },
      { service: 'key_cache_requests',           type: 'Cache',         scope: 'KeyCache', name: 'Requests',     attribute: 'Count',         description: '' },
      { service: 'read_timeout_exceptions',      type: 'ClientRequest', scope: 'Read',     name: 'Timeouts',     attribute: 'Count',         description: '' },
      { service: 'write_timeout_exceptions',     type: 'ClientRequest', scope: 'Write',    name: 'Timeouts',     attribute: 'Count',         description: '' },
      { service: 'read_unavailable_exceptions',  type: 'ClientRequest', scope: 'Read',     name: 'Unavailables', attribute: 'Count',         description: '' },
      { service: 'write_unavailable_exceptions', type: 'ClientRequest', scope: 'Write',    name: 'Unavailables', attribute: 'Count',         description: '' }
    ]
  end
end
